/*
 * CumulativeDistribution.java
 *
 * Created on April 6, 2006, 2:00 PM
 *
/* NewGarden 
/*
/* Copyright  2005-2011 Stephan Pelikan and Steven Rogstad
/* contact:  pelikan@math.uc.edu
/*
/* This program is free software; you can redistribute it and/or modify
/* it under the terms of the GNU Library General Public License as published 
/* by  the Free Software Foundation; either version 3 of the License or
/* (at your option) any later version.
/*
/* This program is distributed in the hope that it will be useful, but
/* WITHOUT ANY WARRANTY; without even the implied warranty of
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/* GNU Library General Public License for more details.
/*
/* You should have received a copy of the GNU  General Public License
/* along with this program; see the file gpl-3.0.txt  If not, write to 
/* the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
/* Boston, MA  02111-1307 USA

 */

/**
 *
 * @author sep
 */
public class CumulativeDistribution extends SampledFunction{
    static final boolean DEBUG=false;
    /** Creates a new instance of CumulativeDistribution */
    
    
    
    public CumulativeDistribution(double []xx, double [] yy) {
        super(yy,xx);
        if(DEBUG)
        {
            if(yy[yy.length-1]!=1.0)
            {
                System.out.println("Creating a CDF without max value 1.0");
            }
          //  if(! isMonotone())
          //  {
          //      System.out.println("The CDF isn't monotone");
          //  }
        }
     
        assert yy[yy.length-1]==1.0;
        
    }
    public boolean isMonotone()
    {
        boolean monotone=true;
        int i=1;
        while(i<x.length && monotone)
        {
            if(y[i-1]>y[i]) {monotone=false;}
            i++;
        }
        return monotone;
    }
   
     public static void main(String[] args) {
        // TODO code application logic here
         double []dx = {0.0,1.0,2.0,3.0};
    double [] dy={0.25,0.5,0.75,1.0};
        CumulativeDistribution cdf=new CumulativeDistribution(dx,dy);
        int v= (int)Math.floor(cdf.value(0.7))+1;
        System.out.println(v);
    }
}
