/*
 * Location.java
 *
/* Copyright  2005-2011 Stephan Pelikan and Steven Rogstad
/* contact:  pelikan@math.uc.edu
/*
/* This program is free software; you can redistribute it and/or modify
/* it under the terms of the GNU Library General Public License as published 
/* by  the Free Software Foundation; either version 3 of the License or
/* (at your option) any later version.
/*
/* This program is distributed in the hope that it will be useful, but
/* WITHOUT ANY WARRANTY; without even the implied warranty of
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/* GNU Library General Public License for more details.
/*
/* You should have received a copy of the GNU  General Public License
/* along with this program; see the file gpl-3.0.txt  If not, write to 
/* the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
/* Boston, MA  02111-1307 USA
 * Created on February 28, 2005, 6:45 PM
 */

/**
 * This class is used to store the location (essentially
 * x and y coordinates) of a plant
 * @author sep
 */
public class Location {
    
    /** Creates a new instance of Location */
    public Location() {
    }
    int X,Y;
    /**
     * Create a location given the coordinates for it
     * @param x the x coordinate of the location
     * @param y the y coordinate of the location
     */
    public Location(int x, int y){X=x; Y=y;}
    /**
     * Retruns a String version of the location
     * @return String to display/print the location
     */
    @Override
    public String toString(){return ("location:(X = "+X+",Y = "+Y+")");}
    /**
     * Returns the distance between this location and l
     * Distance is measured as 1-norm.
     * @param l the location to find the distance to
     * @return The 1-norm distance from here to l
     */
    public float dist(Location l)
    {
        return (float)Math.max(Math.abs(l.X-X),Math.abs(l.Y-Y));
        
    }
    Location add(Location l)
    {
        return(new Location(X+l.X,Y+l.Y));
    }
    boolean equals(Location l)
    {
        return( X==l.X && Y==l.Y);
        //above is superior to below based on profile of process
        //
       // if((X-l.X)* (X-l.X)+ (Y-l.Y)*  (Y-l.Y)==0) return true;
       // return false;
    }
}
