/*
 * ProgressFrame.java
part of program  NewGarden 
/*
/* Copyright  2005-2011 Stephan Pelikan and Steven Rogstad
/* contact:  pelikan@math.uc.edu
/*
/* This program is free software; you can redistribute it and/or modify
/* it under the terms of the GNU Library General Public License as published 
/* by  the Free Software Foundation; either version 3 of the License or
/* (at your option) any later version.
/*
/* This program is distributed in the hope that it will be useful, but
/* WITHOUT ANY WARRANTY; without even the implied warranty of
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/* GNU Library General Public License for more details.
/*
/* You should have received a copy of the GNU  General Public License
/* along with this program; see the file gpl-3.0.txt  If not, write to 
/* the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
/* Boston, MA  02111-1307 USA
 *
 *
 *
 */

package ProgressFrame;
import javax.swing.*;
import java.awt.*;
/**
 *
 * @author sep
 */
public class ProgressFrame extends JFrame{
    JProgressBar [] progbars;
  
    /** Creates a new instance of ProgressFrame */
    public ProgressFrame(int n_bars, String []labels) {
        super(labels[0]);
        progbars=new JProgressBar[n_bars];
        this.getContentPane().setLayout(new GridLayout(n_bars,2));
        for(int i=0;i<n_bars;i++)
        {
            progbars[i]=new JProgressBar(0,100);
            progbars[i].setStringPainted(true);
            progbars[i].setPreferredSize(new Dimension(200,40));
            this.getContentPane().add(new JLabel(labels[i+1]));
            this.getContentPane().add(progbars[i]);
        }
        this.setSize(300,90);
        this.setVisible(true);
    }
    public int makePercent(double x, double y )
    {
        return (int)Math.floor(100*x/y);
    }
    public void setValue(int bar,int v)
    {
        progbars[bar].setValue(v);
    }

    public void done()
    {
        this.setVisible(false);
        this.dispose();
    }
   
}
