

/*Rect.java
/* Copyright  2005-2011 Stephan Pelikan and Steven Rogstad
/* contact:  pelikan@math.uc.edu
/*
/* This program is free software; you can redistribute it and/or modify
/* it under the terms of the GNU Library General Public License as published 
/* by  the Free Software Foundation; either version 3 of the License or
/* (at your option) any later version.
/*
/* This program is distributed in the hope that it will be useful, but
/* WITHOUT ANY WARRANTY; without even the implied warranty of
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/* GNU Library General Public License for more details.
/*
/* You should have received a copy of the GNU  General Public License
/* along with this program; see the file gpl-3.0.txt  If not, write to 
/* the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
/* Boston, MA  02111-1307 USA
 * 
 */
/**
 *
 * @author Steve
 */
import java.util.*;
import java.text.NumberFormat;

public class Rect {

    float XL, XH, YL, YH;
    int LEFT, RIGHT, TOP, BOTTOM;

    public Rect(float xl, float yl, float xh, float yh) {
        XL = xl;
        XH = xh;
        YL = yl;
        YH = yh;
        LEFT = (int) XL;
        RIGHT = (int) XH;
        TOP = (int) YH;
        BOTTOM = (int) YL;

    }

    boolean inRect(float x, float y) {
        if (x < XL || x > XH || y < YL || y > YH) {
            return false;
        }
        return true;
    }

    public String toXML() {
        NumberFormat nf = NumberFormat.getInstance();
        nf.setMaximumFractionDigits(2);
        StringBuilder sb = new StringBuilder();
        sb.append("<Rectangle XL=\"" + nf.format(XL) + "\" ");
        sb.append("YL=\"" + nf.format(YL) + "\" ");
        sb.append("XH=\"" + nf.format(XH) + "\" ");
        sb.append("YH=\"" + nf.format(YH) + "\" />\n");
        return (sb.toString());
    }
}

