/*SimDataReadeer.java based on
 * ModelBuilder.java
 *Part of NewGarden

/* Copyright  2005-2011 Stephan Pelikan and Steven Rogstad
/* contact:  pelikan@math.uc.edu
/*
/* This program is free software; you can redistribute it and/or modify
/* it under the terms of the GNU Library General Public License as published 
/* by  the Free Software Foundation; either version 3 of the License or
/* (at your option) any later version.
/*
/* This program is distributed in the hope that it will be useful, but
/* WITHOUT ANY WARRANTY; without even the implied warranty of
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/* GNU Library General Public License for more details.
/*
/* You should have received a copy of the GNU  General Public License
/* along with this program; see the file gpl-3.0.txt  If not, write to 
/* the Free Software Foundation Inc., 59 Temple Place - Suite 330, 
/* Boston, MA  02111-1307 USA

 * Created on August 30, 2003
 * adapted to Biglist project Decemeber 29, 2003
 * this version is for newgarden paramater files
 */

/**
 *
 * @author  sep
 */

//Model Builder - extends DefaultHandler for parsing the xml in the taxa.dtd data type


import java.util.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;



class SimDataReader extends DefaultHandler {
    Stack stack;
    Object topguy;
    static final boolean DEBUG=false;
    public SimDataReader() {
        if(DEBUG) System.out.println("SimDataReader()");
        stack=new Stack();
    }
    
    public SimData getSD() {
        return (SimData) stack.pop();
    }
    
    //what to do when we get character data
    @Override
    public void characters(char []ch,int start,int len) {
        //TempElement el=(TempElement)stack.peek();
        String s=new String(ch,start,len);
        System.out.println("Problem: asked to handle characters"+s);
    }
    //how to end an element
    @Override
    public void endElement(String ns,String ln,String qname) throws SAXException {
        
        if(stack.empty()) {
            System.out.println("Hey --- stack is empty!");
        }
        
           if(qname.equals("EasyPollen"))
        {
            ArrayList ourFrames=(ArrayList)stack.pop();
            SimData sd=(SimData) stack.peek();
            //create a sampledfunction that might have been read 
            //in as a PollenDistances
            SampledFunction sf=new SampledFunction();
            for(int i=0;i<ourFrames.size()-1;i++)
            {
                String framedata[]=(String [])ourFrames.get(i);
                //add the point i,framedata[1] to the sampledfunction
                sf.addPoint(i, Double.parseDouble(framedata[1]));
            }
            //now do what /PollenDistance does with its sampledfunction
           
            sd.pollen_distances=new int[sf.y.length];
            //faster(?) is 
            for(int i=0;i<sd.pollen_distances.length;i++)
                sd.pollen_distances[i]=(int)Math.floor(sf.y[i]);
            //better is this
           // for(int i=0;i<sd.pollen_distances.length;i++)
           // {
            //    sd.pollen_distances[i]=(int)Math.floor(sf.value(i));
            //}
            //Now do the same with the probabilities
            //First make a sampledfunection
            sf=new SampledFunction();
            for(int i=0;i<ourFrames.size();i++)
            {
                String [] framedata =(String [])ourFrames.get(i);
                sf.addPoint(Double.parseDouble(framedata[2]),i);
            }
            sd.pollen_distance_probabilities=new DiscreteProbabilityDistribution();
            //better is probably this, which doesn't assume the xml elements are in the right order
            for(int i=0;i<sf.x.length;i++)
            {
                sd.pollen_distance_probabilities.addPoint((float)sf.x[i],(float)sf.y[i]);
            }
        sd.pollen_distance_probabilities.normalize();
            
        }
        
        //insert this element into its parent in the correct way
        
        
        //If it is a locus, normalize the dpd
        //put it in the array of loci
        
        if(qname.equals("locus")) {
            
            //pop the locus
            //put it in sd.Loci
            Locus l=(Locus) stack.pop();
            l.dpd.normalize();
            SimData sd=(SimData) stack.peek();
            sd.loci.add(l);
            
        }
        //end LOCI by setting number_loci to size of loci and triptosize
        if(qname.equals("Reproduction_Rate")) {
            
            //pop the the sampled function
            //put it in sd.R_R
            SampledFunction sf=(SampledFunction) stack.pop();
            SimData sd=(SimData) stack.peek();
            sd.fruit_production=sf;
            
        }
         if(qname.equals("Dispersal_Distribution")) {
            
            //pop the the sampled function
            //put it in sd.R_R
            CDF cdf=(CDF) stack.pop();
            //SampledFunction sf=(SampledFunction) stack.pop();
            SimData sd=(SimData) stack.peek();
            sd.dispersal_distribution=cdf;
            
        }
        
        if(qname.equals("Mortality_Rate")) {
            
            //pop the the sampled function
            //put it in sd.R_R
            SampledFunction sf=(SampledFunction) stack.pop();
            SimData sd=(SimData) stack.peek();
            sd.mortality=sf;
            
        }
        //new pollen stuff 7 april 06
         if(qname.equals("Pollen_Distances")) {
            
            //pop the the sampled function
            //put it in sd.R_R
            SampledFunction sf=(SampledFunction) stack.pop();
            SimData sd=(SimData) stack.peek();
            sd.pollen_distances=new int[sf.y.length];
            //faster(?) is 
            for(int i=0;i<sd.pollen_distances.length;i++)
                sd.pollen_distances[i]=(int)Math.floor(sf.y[i]);
            //better is this
            for(int i=0;i<sd.pollen_distances.length;i++)
            {
                sd.pollen_distances[i]=(int)Math.floor(sf.value(i));
            }
        }
        
         if(qname.equals("Pollen_Distance_Probabilities")) {
            
            //pop the the sampled function
            //put it in sd.R_R
            SampledFunction sf=(SampledFunction) stack.pop();
            SimData sd=(SimData) stack.peek();
            //sd.pollen_distance_probabilities=new DiscreteProbabilityDistribution(sf.x,sf.y);
sd.pollen_distance_probabilities=new DiscreteProbabilityDistribution();
            //better is probably this, which doesn't assume the xml elements are in the right order
            for(int i=0;i<sf.x.length;i++)
            {
                sd.pollen_distance_probabilities.addPoint((float)sf.x[i],(float)sf.y[i]);
            }
sd.pollen_distance_probabilities.normalize();
            
        }
        //end new pollen stuff
      
        
        if(qname.equals("Pollen_Rate")) {
            
            //pop the the sampled function
            //put it in sd.R_R
            SampledFunction sf=(SampledFunction) stack.pop();
            SimData sd=(SimData) stack.peek();
            sd.pollen_production=sf;
            
        }
        //Initial_Population --- we can trip sd.plants to size
        //region pop it and put it in sd
         if(qname.equals("Region")) {
            Region r= (Region)stack.pop();
             //SimData sd=(SimData)stack.peek();
            //sd.region=r;
            //when we allow summary subregions, we need
            //to determine whether the parent is
            //the SimData or a summaryregion
            //and cast accordingly
            if(stack.peek().getClass().getName().equals("SimData"))
            {
                SimData sd=(SimData)stack.peek();
                sd.region=r;
            }
            else{
                if(stack.peek().getClass().getName().equals("SummaryRegions"))
                {
                    SummaryRegions sr=(SummaryRegions)stack.peek();
                    sr.addRegion(r);
                }
                //region is one of the summary subregions
            }
         }
         if(qname.equals("SummaryRegions")) {
             SummaryRegions sr=(SummaryRegions)stack.pop();
              SimData sd=(SimData)stack.peek();
              sd.summaryregions=sr;
         }
         
         if(qname.equals("ConvexPolygon")) {
             ConvexPolygon cp= (ConvexPolygon)stack.pop();
             Region r=(Region)stack.peek();
      
             r.addPoly(cp);
            
         }
        
        /*
          if(qname.equals("Rectangle")) {
            Rectangle r= (Rectangle)stack.pop();
            Region reg=(Region)stack.peek();
            reg.addRect(r);
          }
         * */
        /*
        if(qname.equals("Region"))
        {
            SimData sd=(SimData)stack.peek();
            sd.MakeFinal();
       }
        */
    }
    @Override
    public void startElement(String ns, String ln,String qname,Attributes at) throws SAXException {
        //get these in the right order
        //Region
        if(qname.equals("SummaryRegions"))
        {
            SummaryRegions sr=new SummaryRegions();
            stack.push(sr);
        }
        if(qname.equals("Region")) {
            int l=0,r=0,bot=0,top=0;
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("XL")) {
                    l=(int)Float.parseFloat(t);
                } else if(s.equals("XH")) {
                    r=(int)Float.parseFloat(t);
                } else if(s.equals("YL")) {
                    bot=(int)Float.parseFloat(t);
                } else if(s.equals("YH")) {
                    top=(int)Float.parseFloat(t);
                }
                //and now parse "old style" attributes
                else if(s.equals("TOP")) {
                    top=(int)Float.parseFloat(t);
                }
                 else if(s.equals("BOTTOM")) {
                    bot=(int)Float.parseFloat(t);
                }
                 else if(s.equals("LEFT")) {
                    l=(int)Float.parseFloat(t);
                }
                 else if(s.equals("RIGHT")) {
                    r=(int)Float.parseFloat(t);
                }
            }
            Region region=new Region(l,bot,r,top);
            stack.push(region);
        } 
       // /*NEW TO PARSE RECTANGLES INSIDE A REGION
         if(qname.equals("Rectangle")) {
            int l=0,r=0,bot=0,top=0;
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("XL")) {
                    l=(int)Float.parseFloat(t);
                } else if(s.equals("XH")) {
                    r=(int)Float.parseFloat(t);
                } else if(s.equals("YL")) {
                    bot=(int)Float.parseFloat(t);
                } else if(s.equals("YH")) {
                    top=(int)Float.parseFloat(t);
                }
            }
            Rect rect=new Rect(l,bot,r,top);
            //stack.push(rect);
            Region reg=(Region)stack.peek();
            reg.addRect(rect);
        } 
        //If we read a vertex it must belong to a parent ConvexPolygon
        if(qname.equals("Vertex")){
            float x, y;
        x=0;y=0;
             for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("x")) {
                    x=(int)Float.parseFloat(t);
                } else if(s.equals("y")) {
                    y=(int)Float.parseFloat(t);
                } 
        }
            ConvexPolygon cp=(ConvexPolygon)stack.peek();
            cp.addVertex(x, y);
    }
        //if we get a convexpoly, create one and put it on the stack.
        //end it by adding it to the region
      if(qname.equals("ConvexPolygon")){  
          ConvexPolygon cp=new ConvexPolygon();
          stack.push(cp);
      }
     //    */
        //we no longer use this but leave it for
        //backward compat. 7 Dec 2007
         else if(qname.equals("regionpoint")) {
           int a=0,b=0;
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                  if(s.equals("a")) {
                    a=(int)Float.parseFloat(t);
                } 
                  else if(s.equals("b")) {
                    b=(int)Float.parseFloat(t);
                } 
            }
          // Region r=(Region)stack.peek();
           //r.addRLEpoint(a,b);
        } 
        
        else if(qname.equals("Simulation_Data")) {
            SimData element=new SimData();
            stack.push(element);
        } 
        
        else if(qname.equals("LOCI")) {
            int number_automatic_loci=0;
            int auto_alleles_per_locus=0;
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("number_loci")) {
                    //Parent is SimData
                    //
                    int number_loci=Integer.parseInt(t);
                    SimData sd= (SimData) stack.peek();
                    sd.number_loci=number_loci;
                }
                if(s.equals("number_automatic_loci")) {
                    //Parent is SimData
                    //
                    number_automatic_loci=Integer.parseInt(t);
                    SimData sd= (SimData) stack.peek();
                    sd.number_loci+=number_automatic_loci;
                }
                if(s.equals("auto_alleles_per_locus")) {
                    auto_alleles_per_locus=Integer.parseInt(t);
                }
                if(auto_alleles_per_locus>0 && number_automatic_loci>0)
                {
                    //create the requested loci
                    for(int ii=0;ii<number_automatic_loci;ii++)
                    {
                        float prob=1.0f/auto_alleles_per_locus;
                        Locus l=new Locus();
                        //l.dpd.addPoint()
                        for(int allele=0;allele<auto_alleles_per_locus;allele++)
                        {
                            l.dpd.addPoint(prob,allele);
                        }
                         l.dpd.normalize();
                        SimData sd=(SimData) stack.peek();
                        sd.loci.add(l);
                    }
                }
            }
        } else if(qname.equals("locus")) {
            Locus l = new Locus();
            stack.push(l);
        } else if(qname.equals("dpdpoint")) {
            Locus l=(Locus)stack.peek();
            float x=0.0f;
            float y=0.0f;
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("x")) {
                    x=Float.parseFloat(t);
                } else if(s.equals("y")) {
                    y=Float.parseFloat(t);
                }
            }
            l.dpd.addPoint(x,y);
        } else if (
                (qname.equals("Reproduction_Rate")) ||
                (qname.equals("Pollen_Rate")) ||
                (qname.equals("Mortality_Rate") )
                //new pollen stuff 7 april 06
                ||(qname.equals("Pollen_Distances"))
                ||(qname.equals("Pollen_Distance_Probabilities"))
                //end new pollen stuff
                ) {
            SampledFunction sf= new SampledFunction();
            stack.push( sf);
            
        } 
         //NEW FOR EASYPOLLEN
        else if( qname.equals("EasyPollen"))
        {
            //put a list on the stack in which we'll accumulate pollenframes
            //when this element ends, pop it, parse it,
            //and create the Pollen_Distances
            // and Pollen_Distance_Probabilities structures
            stack.push(new ArrayList());
        }
        else if(qname.equals("pollenframe"))
        {
            //put the data into the list on the stack
            //get low high &prob
            //we only get apollenframe element inside an EasyPollen
            //element so there's an ArrayList on the stack waiting
            //for our data.
            String framedata[] = new String[3];
             for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("low")){
                    framedata[0]=t;
                } else if(s.equals("high")) {
                    framedata[1]=t;
                }
                else if(s.equals("prob"))
                {
                    framedata[2]=t;
                }
            }
            ((ArrayList)stack.peek()).add(framedata);
        }
        else if (
                (qname.equals("Dispersal_Distribution")) 
                ) {
            CDF cdf= new CDF();
            stack.push( cdf);
            
        } 
     //   else if(qname.equals("OffspringDistribution"))
     //   {
     //       //parent is sd
     //        SimData sd=(SimData)stack.peek();
             
     //   }
        else if(qname.equals("functionpoint")) {
            SampledFunction sf=(SampledFunction) stack.peek();
            float x=0.0f;
            float y=0.0f;
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("x")) {
                    x=Float.parseFloat(t);
                } else if(s.equals("y")) {
                    y=Float.parseFloat(t);
                }
            }
            sf.addPoint(x,y);
        } else if(qname.equals("Dioecious")) {
            //parent is SimData
            SimData sd= (SimData)stack.peek();
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("value")) {
                    if(t.equals("false")) sd.dioeceous=false;
                    else sd.dioeceous=true;
                }
            }
        }
        else if(qname.equals("Offspring_Distribution")){
            SimData sd=(SimData)stack.peek();
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("method")) {
                    if(t.equals("round")) sd.off_dist_method="round";
                    else if(t.equals("bracket")) sd.off_dist_method="bracket";
                    else if(t.equals("poisson")) sd.off_dist_method="poisson";
                }
            }
        }
        else if(qname.equals("Number_Generations")) {
            //parent is SimData
            SimData sd= (SimData)stack.peek();
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("value")) {
                    sd.number_generations=(int)Math.round(Float.parseFloat(t));
                }
            }
        }
        
        else if(qname.equals("Selfing_Rate")) {
            //parent is SimData
            SimData sd= (SimData)stack.peek();
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("value")) {
                    sd.selfing_rate=Float.parseFloat(t);
                }
            }
        }
        else if(qname.equals("FoundersF")) {
            //parent is SimData
            SimData sd= (SimData)stack.peek();
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("value")) {
                    sd.foundersf=Float.parseFloat(t);
                    
                }
            }
        }
        else if(qname.equals("RandomMating")) {
            //parent is SimData
            SimData sd= (SimData)stack.peek();
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("value")) {
                    if(t.equals("true")) sd.random_mating=true;
                    else sd.random_mating=false;
                    //sd.selfing_rate=Float.parseFloat(t);
                }
            }
        }
        else if(qname.equals("Number_Runs")) {
            //parent is SimData
            SimData sd= (SimData)stack.peek();
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("value")) {
                    sd.number_runs=(int) Math.round(Float.parseFloat(t));
                }
            }
        } else if(qname.equals("Fruit_Distance")) {
            //parent is SimData
            SimData sd= (SimData)stack.peek();
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("value")) {
                    sd.fruit_distance=Float.parseFloat(t);
                }
            }
        } else if(qname.equals("Pollen_Distance")) {
            //parent is SimData
            SimData sd= (SimData)stack.peek();
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                if(s.equals("value")) {
                    sd.pollen_distance=Float.parseFloat(t);
                }
            }
        } else if(qname.equals("Plant")) {
            //parent is SimData
            SimData sd= (SimData)stack.peek();
            int age=0,X=0,Y=0;
            boolean femaleP=true;
            for(int i=0;i<at.getLength();i++) {
                String s=at.getQName(i);
                String t=at.getValue(i);
                //age,X,Y,femaleP
                if(s.equals("age")) {
                    age=(int)Math.round((double)Float.parseFloat(t));
                } else if(s.equals("X")) {
                    X=(int)Math.round((double)Float.parseFloat(t));
                } else if(s.equals("Y")) {
                    Y=(int)Math.round((double)Float.parseFloat(t));
                } else if(s.equals("femaleP")) {
                    if(t.equals("true")) femaleP=true;
                    else femaleP=false;
                }
            }
            //make a Plant
            Location l=new Location(X,Y);
            //dump it if not in our Region
            //number_loci=loci.size();
            Plant ourplant=new Plant(sd.loci.size(),age,l);
            ourplant.female=femaleP;
            ourplant.parent1=-1;
            ourplant.parent2=-1;
            sd.plants.add(ourplant);
            
        }
        
        
        
    }
}





